***********************************************************************
*  @START_COPYRIGHT@                                                  *
*  Statement:     Licensed Materials - Property of IBM                *
*                                                                     *
*                 5655-A95                                            *
*                 (C) Copyright IBM Corporation. 2006                 *
*                                                                     *
*  Status:        Version 1 Release 0                                 *
*  @END_COPYRIGHT@                                                    *
*                                                                     *
*  Module Name  : GETECB                                              *
*                                                                     *
*  Environment  : MVS BATCH; C/370                                    *
*                                                                     *
*  Description  : The purpose of this module is to return the         *
*                 address of the ECB to the caller                    *
*                                                                     *
***********************************************************************
*
GETECB   CSECT
GETECB   AMODE 31
GETECB   RMODE ANY
*
R1       EQU     1
R2       EQU     2
R3       EQU     3
R7       EQU     7
R9       EQU     9
R10      EQU     10
R11      EQU     11
R12      EQU     12
R13      EQU     13
R14      EQU     14
R15      EQU     15
*
         STM   R14,R12,12(R13)   Save callers regs
         BALR    R10,0
         USING *,R10             MODULE ADDRESSABILITY
         B     PAST_PROLOG         Skip Eyecatcher
         DC    AL1(PAST_PROLOG-*)  Eyecatcher length
         DC    CL8'GETECB',CL8'&SYSDATC' Eyecatcher for dumps
*
***********************************************************************
* STANDARD ENTRY LINKAGE                                              *
***********************************************************************
*
PAST_PROLOG DS 0H
         LR      R15,R13         Save Callers SA
         LA      R13,SV          Address my SA
         ST      R15,4(,R13)     Chain My SA to Callers
         ST      R13,8(,R15)     Chain Callers SA to Mine
         LTR     R2,R1           SAVE PARAMETER LIST FOR LATER
         BZ      NOPARM          AN ERROR HAS OCCURED
         LA      R9,COMADDR      GET COMMUNICATIONS AREA
*                                ADDRESS AT COMADDR
***********************************************************************
* OBTAIN ADDRESS OF THE CIB                                           *
***********************************************************************
*
         EXTRACT (R9),FIELDS=COMM,MF=(E,EXTRACT)
*                       EXTRACT THE COMMUNICATIONS AREA

         L       R9,COMADDR      GET ADDRESS OF THE AREA
         USING   COM,R9          USE R9 AS BASE ADDRESS OF COMM AREA
         ICM     R7,15,COMCIBPT  GET CIB ADDRESS FROM COM AREA
         BZ      NOCIB           NO CIB, TASK WAS NOT STARTED
         BAL     R14,DOCIB       PROCESS THE CIB
*
NOCIB    DS 0H
         QEDIT ORIGIN=COMCIBPT,CIBCTR=5
*                                SET MODIFY LIMIT TO 5
         B     *+4(R15)        Test RC
         B     QEDIT_OK        RC=0
         B     QEDIT_RC4
         B     QEDIT_RC8
QEDIT_OK DS    0H
         L     R7,COMECBPT     GET ADDRESS OF THE COMMUNICATION ECB
         O     R7,HIBITON      SET HIGH BIT - LAST ECB IN LIST
         ST    R7,MODECB       PUT ADDR OF MODIFY ECB IN LIST
*
*
WAIT     DS 0H
*        WAIT ECBLIST=ECBS       WAIT FOR A MODIFY/STOP
         L     R3,0(,R2)         LOAD ADDRESS OF FIRST PARAMETER
         ST    R7,0(,R3)         SAVE THE ECB ADDRESS IN THE PARAMETER
         B     EXIT
*
QEDIT_RC4 DS   0H
         WTO   'GETECB QEDIT RC=4'
         B     EXIT
QEDIT_RC8 DS   0H
         WTO   'GETECB QEDIT RC=8'
         B     EXIT
* WHEN POSTED HERE, A MODIFY OR STOP HAS BEEN ISSUED
         ICM   R7,15,COMCIBPT    GET CIB ADDRESS FROM COM AREA
         USING CIB,R7            BASE CIB MAPPING
         CLI   CIBVERB,CIBMODFY  MODFY WAS IT A MODIFY?
         BNE   NOTMDFY           GO FREE CIB
         BAL   R14,DOCIB         IT WAS A MODIFY, GO PROCESS COMMAND
*
***********************************************************************
* FREE THE CIB                                                        *
***********************************************************************
*
NOTMDFY  DS   0H
         BAL  R14,DELCIB         FREE CIB
         CLI  CIBVERB,CIBSTOP    WAS IT A STOP?
         B    WAIT               WAIT FOR ANOTHER MODIFY
*
DELCIB   DS   0H
* USE QEDIT TO FREE THE CIB
* QEDIT WILL ALSO CLEAR THE ECB
*
         QEDIT ORIGIN=COMCIBPT,BLOCK=(R7) FREE THE CIB
         BR    R14

DOCIB    DS    0H
         WTO   'GETECB has a CIB'
***********************************************************************
* NO PARAMETERS GIVEN SO AN ERROR HAS OCCURED.                        *
***********************************************************************
*
NOPARM   WTO   'NO PARAMETERS GIVEN'
         B     EXIT
*
***********************************************************************
* Program exit                                                        *
***********************************************************************
EXIT     DS    0H
         L     R13,4(,R13)       Point to callers SA
         LM    R14,R12,12(R13)   Restore caller's regs
         BR    R14               Return to caller
*
***********************************************************************
* CONSTANTS                                                           *
***********************************************************************
*
         DS    0F                FULLWORD ALIGNMENT
HIBITON  DC    X'80000000'       USED TO TURN HIGH ORDER BIT ON
*
***********************************************************************
* FIELDS REQUIRED IN DYNAMIC STORAGE                                  *
***********************************************************************
*
ECBS     DS     0CL4             ECB LIST FOR WAIT
MODECB   DS     A                ADDR(MODIFY/STOP ECB)
COMADDR  DS     F                ADDR(COMAREA) FROM EXTRACT
SV       DS     18F              SAVE AREA
EXTRACT  EXTRACT MF=L            EXTRACT PARAMETER LIST
*
***********************************************************************
* REQUIRED DSECTs                                                     *
***********************************************************************
*
COM      DSECT
         IEZCOM ,                COM AREA
CIB      DSECT
         IEZCIB ,                CIB
         END
